part of example.basic_auth.server;

/// This route group contains login and logout routes
@Api()
class AuthRoutes extends Object with JsonRoutes {
  JsonRepo get repo => jsonRepo;

  @Post(path: '/login')
  @WrapOne(#basicAuth)
  Response<String> login(Context ctx) {
    final User user = ctx.getInput<User>(BasicAuth);
    return toJson(user);
  }

  @Post(path: '/logout')
  void logout(Context ctx) {
    //TODO logout
  }

  BasicAuth basicAuth(Context ctx) => new BasicAuth(kModelManager);
}

/// Collection of routes students can also access
@Api(path: '/book')
@WrapOne(#authorizer)
class StudentRoutes extends Object with JsonRoutes {
  JsonRepo get repo => jsonRepo;

  @Get()
  Response<String> getAllBooks(Context ctx) {
    return toJson(_books.values);
  }

  @Get(path: '/:id')
  Response<String> getBook(Context ctx) {
    String id = ctx.pathParams.get('id');
    Book book = _books[id];
    return toJson(book);
  }

  Authorizer authorizer(Context ctx) => new Authorizer(kModelManager);
}
